<< problem 549 - Divisibility of factorials | Divisibility of sum of divisors - problem 565 >> |
Problem 563: Robot Welders
(see projecteuler.net/problem=563)
A company specialises in producing large rectangular metal sheets, starting from unit square metal plates.
The welding is performed by a range of robots of increasing size. Unfortunately, the programming options of these robots are rather limited.
Each one can only process up to 25 identical rectangles of metal, which they can weld along either edge to produce a larger rectangle.
The only programmable variables are the number of rectangles to be processed (up to and including 25), and whether to weld the long or short edge.
For example, the first robot could be programmed to weld together 11 raw unit square plates to make a 11x1 strip.
The next could take 10 of these 11x1 strips, and weld them either to make a longer 110x1 strip, or a 11x10 rectangle.
Many, but not all, possible dimensions of metal sheets can be constructed in this way.
One regular customer has a particularly unusual order. He always demands that the finished product should have an exact area,
and that the long side must not be more than 10% larger than the short side.
If these requirements can be met in more than one way, in terms of the exact dimensions of the two sides, then he demands that all variants are produced.
For example, if he were to ask for metal sheet of area 889200, then there are three final dimensions that can be produced: 900x988, 912x975 and 936x950.
The target area of 889200 is the smallest area which can be manufactured in three different variants, within the limitations of the robot welders.
Let M(n) be the minimal area that can be manufactured in exactly n variants with the longer edge not greater than 10% bigger than the shorter edge.
Hence M(3) = 889200.
Find sum^100_{n=2}{M(n)}.
My Algorithm
The welding process start with a unit square. Using zero welding steps, these sizes are available:
S_0 = \{ 1 \}
The first welding machine can weld 2 to 25 of those unit square sheets:
S_1 = \{ 2,3,4,5,..,23,24,25 \}
The second welding machine can weld 2 to 25 sheets from the first step:
S_2 = \{ 2*2,2*3,2*4,...,2*24,2*25, \space 3*2,3*3,...,3*25, \space 4*2,...,4*25,...,25*2,25*3,...,25*25 \}
Some of those sheets have the same size, e.g. 2*3 = 3*2 or 2*4 = 8 (→ step 2 produces a sheet that has already been made in step 1 as well).
After a few steps, these sizes are available:
S = \{ 2^a * 3^b * 4^c * 5^d * ... * 24^x * 25^y \}
Because of 24^x = 8^x * 3^x = 2^{3x} * 3^x I can increase the number of steps (there's no limit of welding machines)
and demand that all machines can only weld a prime numbers of sheets.
We are left with 9 welding groups (the nine primes <= 25): 2, 3, 5, 7, 11, 13, 17, 19, 23
That means that all areas 2^a 3^b 5^c 7^d 11^e 13^f 17^g 19^h 23^i can be produced by the welding machines.
When I generate them in ascending order I have to check their side lengths whether a <= b and b / a <= 11 / 10 → 11a >= 10b (b doesn't exceed a by more than 10%).
I use a min-heap (implemented as a priority queue) to generate all such areas.
Whenever the next area A is picked from the min-heap I find its highest prime factor p_k (it must be one of the nine mentioned above)
and add p_k * A, p_{k+1} * A, ..., 23 * A to the min-heap.
Since each area A can be generated as Ax1 (a very long strip one unit wide and A units long), the potential side lengths are identical to the areas.
Therefore I search for each area A all smaller areas a and b. The first edge case is a = b and the second is b / a = 11 / 10 (which can be written as 11a = 10b).
The first edge case means a = sqrt{A}. I slowly decrement a and find all b such that a * b = A until 11a = 10b.
Note
I don't generate areas larger than 2300000000000000 because M(100) is smaller than that and I won't need those larger numbers at all.
Looking at my log output I immediately saw that all M() are divisible by 10.
And further analysis showed:
- every M(>= 2) is divisible by 40
- every M(>= 9) is divisible by 80
- every M(>= 53) is divisible by 800 (which is in fact the 56th number found)
Running these three divisibility checks before computing the actual number of variants made my program about three times as fast (see
#define FAST
).STL's
priority_queue
needs a container to store the data. The faster choice is std::vector
(about 10% faster)but
std::deque
needs about 50% less memory because frequent reallocations are mostly avoided.
Interactive test
You can submit your own input to my program and it will be instantly processed at my server:
This is equivalent toecho 3 | ./563
Output:
Note: the original problem's input 100
cannot be entered
because just copying results is a soft skill reserved for idiots.
(this interactive test is still under development, computations will be aborted after one second)
My code
… was written in C++11 and can be compiled with G++, Clang++, Visual C++. You can download it, too. Or just jump to my GitHub repository.
#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include <functional>
#include <cmath>
int main()
{
// highest number of combinations
unsigned int maxCombinations = 100;
std::cin >> maxCombinations;
// problem asks for 2..100 => that means without M(1), just pretend it's already solved
const auto NoSolution = 0ULL;
unsigned int numSolutions = 1;
std::vector<unsigned long long> solutions(maxCombinations + 1, NoSolution);
// add all solutions
unsigned long long result = 0;
// create a min-heap
typedef std::deque<unsigned long long> Container;
//typedef std::vector<unsigned long long> Container; // a bit faster but needs almost 50% more memory
std::priority_queue<unsigned long long, Container, std::greater<unsigned long long>> areas;
// start with a single unit square
areas.push(1);
// each area will be equal to a side
std::vector<unsigned long long> sides;
// performance tweak: the correct result is below this value, don't generate larger numbers
// => just to save memory and speed up the process
const auto IgnoreAbove = 2300000000000000ULL;
// until I found enough solutions
while (numSolutions < maxCombinations)
{
// get next area
auto current = areas.top();
areas.pop();
// will be the side length of a larger area, too
if (current * current <= IgnoreAbove)
sides.push_back(current);
// insert all possible areas that can be produced by multiplying the current area with all primes between 2 and 25
const unsigned char multiples[] = { 23,19,17,13,11,7,5,3,2 };
for (auto multiple : multiples)
{
auto next = multiple * current;
if (next <= IgnoreAbove)
areas.push(next);
// smaller primes were already taken care of (=> "next" already exists in "areas")
if (current % multiple == 0)
break;
}
#define FAST
#ifdef FAST
// some heuristics based on the solutions I found
if (numSolutions >= 56)
{
if (current % 800 != 0)
continue;
}
else
if (numSolutions >= 8)
{
if (current % 80 != 0)
continue;
}
else
if (current % 40 != 0)
continue;
#endif
// maximum length of the shorter side is sqrt(current area)
auto iteLow = std::upper_bound(sides.begin(), sides.end(), (unsigned long long)sqrt(current));
// upper_bound deliberately picks a value that is a tiny bit too large
// one step back => longest possible length of the shorter side
iteLow--;
// look for all combinations
unsigned int numFound = 0;
//while (iteLow != areas.begin())
while (iteLow != sides.begin())
{
// compute both sides
auto shortSide = *iteLow--;
auto longSide = current / shortSide;
// violating the 10% rule ?
if (longSide * 10 > shortSide * 11)
break;
// is "current" indeed divisible by "shortSide" ? => then we have one more solution
if (longSide * shortSide == current)
numFound++;
}
// problem asks for 2..100 combinations only
if (numFound < 2 || numFound > maxCombinations)
continue;
// new combination ?
if (solutions[numFound] == NoSolution)
{
solutions[numFound] = current;
result += current;
numSolutions++;
//std::cout << "found " << numFound << "/" << numSolutions << " @ " << current << " +" << result << std::endl;
}
}
// show that large number !
std::cout << result << std::endl;
return 0;
}
This solution contains 19 empty lines, 27 comments and 9 preprocessor commands.
Benchmark
The correct solution to the original Project Euler problem was found in 6.9 seconds on an Intel® Core™ i7-2600K CPU @ 3.40GHz.
Peak memory usage was about 21 MByte.
(compiled for x86_64 / Linux, GCC flags: -O3 -march=native -fno-exceptions -fno-rtti -std=gnu++11 -DORIGINAL
)
See here for a comparison of all solutions.
Note: interactive tests run on a weaker (=slower) computer. Some interactive tests are compiled without -DORIGINAL
.
Changelog
October 11, 2017 submitted solution
October 11, 2017 added comments
Difficulty
Project Euler ranks this problem at 45% (out of 100%).
Links
projecteuler.net/thread=563 - the best forum on the subject (note: you have to submit the correct solution first)
C++ github.com/roosephu/project-euler/blob/master/563.cpp (written by Yuping Luo)
Those links are just an unordered selection of source code I found with a semi-automatic search script on Google/Bing/GitHub/whatever.
You will probably stumble upon better solutions when searching on your own.
Maybe not all linked resources produce the correct result and/or exceed time/memory limits.
Heatmap
Please click on a problem's number to open my solution to that problem:
green | solutions solve the original Project Euler problem and have a perfect score of 100% at Hackerrank, too | |
yellow | solutions score less than 100% at Hackerrank (but still solve the original problem easily) | |
gray | problems are already solved but I haven't published my solution yet | |
blue | solutions are relevant for Project Euler only: there wasn't a Hackerrank version of it (at the time I solved it) or it differed too much | |
orange | problems are solved but exceed the time limit of one minute or the memory limit of 256 MByte | |
red | problems are not solved yet but I wrote a simulation to approximate the result or verified at least the given example - usually I sketched a few ideas, too | |
black | problems are solved but access to the solution is blocked for a few days until the next problem is published | |
[new] | the flashing problem is the one I solved most recently |
I stopped working on Project Euler problems around the time they released 617.
1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 | 21 | 22 | 23 | 24 | 25 |
26 | 27 | 28 | 29 | 30 | 31 | 32 | 33 | 34 | 35 | 36 | 37 | 38 | 39 | 40 | 41 | 42 | 43 | 44 | 45 | 46 | 47 | 48 | 49 | 50 |
51 | 52 | 53 | 54 | 55 | 56 | 57 | 58 | 59 | 60 | 61 | 62 | 63 | 64 | 65 | 66 | 67 | 68 | 69 | 70 | 71 | 72 | 73 | 74 | 75 |
76 | 77 | 78 | 79 | 80 | 81 | 82 | 83 | 84 | 85 | 86 | 87 | 88 | 89 | 90 | 91 | 92 | 93 | 94 | 95 | 96 | 97 | 98 | 99 | 100 |
101 | 102 | 103 | 104 | 105 | 106 | 107 | 108 | 109 | 110 | 111 | 112 | 113 | 114 | 115 | 116 | 117 | 118 | 119 | 120 | 121 | 122 | 123 | 124 | 125 |
126 | 127 | 128 | 129 | 130 | 131 | 132 | 133 | 134 | 135 | 136 | 137 | 138 | 139 | 140 | 141 | 142 | 143 | 144 | 145 | 146 | 147 | 148 | 149 | 150 |
151 | 152 | 153 | 154 | 155 | 156 | 157 | 158 | 159 | 160 | 161 | 162 | 163 | 164 | 165 | 166 | 167 | 168 | 169 | 170 | 171 | 172 | 173 | 174 | 175 |
176 | 177 | 178 | 179 | 180 | 181 | 182 | 183 | 184 | 185 | 186 | 187 | 188 | 189 | 190 | 191 | 192 | 193 | 194 | 195 | 196 | 197 | 198 | 199 | 200 |
201 | 202 | 203 | 204 | 205 | 206 | 207 | 208 | 209 | 210 | 211 | 212 | 213 | 214 | 215 | 216 | 217 | 218 | 219 | 220 | 221 | 222 | 223 | 224 | 225 |
226 | 227 | 228 | 229 | 230 | 231 | 232 | 233 | 234 | 235 | 236 | 237 | 238 | 239 | 240 | 241 | 242 | 243 | 244 | 245 | 246 | 247 | 248 | 249 | 250 |
251 | 252 | 253 | 254 | 255 | 256 | 257 | 258 | 259 | 260 | 261 | 262 | 263 | 264 | 265 | 266 | 267 | 268 | 269 | 270 | 271 | 272 | 273 | 274 | 275 |
276 | 277 | 278 | 279 | 280 | 281 | 282 | 283 | 284 | 285 | 286 | 287 | 288 | 289 | 290 | 291 | 292 | 293 | 294 | 295 | 296 | 297 | 298 | 299 | 300 |
301 | 302 | 303 | 304 | 305 | 306 | 307 | 308 | 309 | 310 | 311 | 312 | 313 | 314 | 315 | 316 | 317 | 318 | 319 | 320 | 321 | 322 | 323 | 324 | 325 |
326 | 327 | 328 | 329 | 330 | 331 | 332 | 333 | 334 | 335 | 336 | 337 | 338 | 339 | 340 | 341 | 342 | 343 | 344 | 345 | 346 | 347 | 348 | 349 | 350 |
351 | 352 | 353 | 354 | 355 | 356 | 357 | 358 | 359 | 360 | 361 | 362 | 363 | 364 | 365 | 366 | 367 | 368 | 369 | 370 | 371 | 372 | 373 | 374 | 375 |
376 | 377 | 378 | 379 | 380 | 381 | 382 | 383 | 384 | 385 | 386 | 387 | 388 | 389 | 390 | 391 | 392 | 393 | 394 | 395 | 396 | 397 | 398 | 399 | 400 |
401 | 402 | 403 | 404 | 405 | 406 | 407 | 408 | 409 | 410 | 411 | 412 | 413 | 414 | 415 | 416 | 417 | 418 | 419 | 420 | 421 | 422 | 423 | 424 | 425 |
426 | 427 | 428 | 429 | 430 | 431 | 432 | 433 | 434 | 435 | 436 | 437 | 438 | 439 | 440 | 441 | 442 | 443 | 444 | 445 | 446 | 447 | 448 | 449 | 450 |
451 | 452 | 453 | 454 | 455 | 456 | 457 | 458 | 459 | 460 | 461 | 462 | 463 | 464 | 465 | 466 | 467 | 468 | 469 | 470 | 471 | 472 | 473 | 474 | 475 |
476 | 477 | 478 | 479 | 480 | 481 | 482 | 483 | 484 | 485 | 486 | 487 | 488 | 489 | 490 | 491 | 492 | 493 | 494 | 495 | 496 | 497 | 498 | 499 | 500 |
501 | 502 | 503 | 504 | 505 | 506 | 507 | 508 | 509 | 510 | 511 | 512 | 513 | 514 | 515 | 516 | 517 | 518 | 519 | 520 | 521 | 522 | 523 | 524 | 525 |
526 | 527 | 528 | 529 | 530 | 531 | 532 | 533 | 534 | 535 | 536 | 537 | 538 | 539 | 540 | 541 | 542 | 543 | 544 | 545 | 546 | 547 | 548 | 549 | 550 |
551 | 552 | 553 | 554 | 555 | 556 | 557 | 558 | 559 | 560 | 561 | 562 | 563 | 564 | 565 | 566 | 567 | 568 | 569 | 570 | 571 | 572 | 573 | 574 | 575 |
576 | 577 | 578 | 579 | 580 | 581 | 582 | 583 | 584 | 585 | 586 | 587 | 588 | 589 | 590 | 591 | 592 | 593 | 594 | 595 | 596 | 597 | 598 | 599 | 600 |
601 | 602 | 603 | 604 | 605 | 606 | 607 | 608 | 609 | 610 | 611 | 612 | 613 | 614 | 615 | 616 | 617 | 618 | 619 | 620 | 621 | 622 | 623 | 624 | 625 |
626 | 627 | 628 | 629 | 630 | 631 | 632 | 633 | 634 | 635 | 636 | 637 | 638 | 639 | 640 | 641 | 642 | 643 | 644 | 645 | 646 | 647 | 648 | 649 | 650 |
651 | 652 | 653 | 654 | 655 | 656 | 657 | 658 | 659 | 660 | 661 | 662 | 663 | 664 | 665 | 666 | 667 | 668 | 669 | 670 | 671 | 672 | 673 | 674 | 675 |
676 | 677 | 678 | 679 | 680 | 681 | 682 | 683 | 684 | 685 | 686 | 687 | 688 | 689 | 690 | 691 | 692 | 693 | 694 | 695 | 696 | 697 | 698 | 699 | 700 |
701 | 702 | 703 | 704 | 705 | 706 | 707 | 708 | 709 | 710 | 711 | 712 | 713 | 714 | 715 | 716 | 717 | 718 | 719 | 720 | 721 | 722 | 723 | 724 | 725 |
726 | 727 | 728 | 729 | 730 | 731 | 732 | 733 | 734 | 735 | 736 | 737 | 738 | 739 | 740 | 741 | 742 | 743 | 744 | 745 | 746 | 747 | 748 | 749 | 750 |
751 | 752 | 753 | 754 | 755 | 756 | 757 | 758 | 759 | 760 | 761 | 762 | 763 | 764 | 765 | 766 | 767 | 768 | 769 | 770 | 771 | 772 | 773 | 774 | 775 |
776 | 777 | 778 | 779 | 780 | 781 | 782 | 783 | 784 | 785 | 786 | 787 | 788 | 789 | 790 | 791 | 792 | 793 | 794 | 795 | 796 | 797 | 798 | 799 | 800 |
801 | 802 | 803 | 804 | 805 | 806 | 807 | 808 | 809 | 810 | 811 | 812 | 813 | 814 | 815 | 816 | 817 | 818 | 819 |
I scored 13526 points (out of 15700 possible points, top rank was 17 out of ≈60000 in August 2017) at Hackerrank's Project Euler+.
My username at Project Euler is stephanbrumme while it's stbrumme at Hackerrank.
Look at my progress and performance pages to get more details.
Copyright
I hope you enjoy my code and learn something - or give me feedback how I can improve my solutions.
All of my solutions can be used for any purpose and I am in no way liable for any damages caused.
You can even remove my name and claim it's yours. But then you shall burn in hell.
The problems and most of the problems' images were created by Project Euler.
Thanks for all their endless effort !!!
<< problem 549 - Divisibility of factorials | Divisibility of sum of divisors - problem 565 >> |